//+------------------------------------------------------------------+
//|                                   Vinin_LRMA_Color&&Sound v2.mq4 |
//|                                        Victor Nicolaev aka Vinin |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "2009, Victor Nicolaev aka Vinin"
#property link      "mailto: vinin@mail.ru"


#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Yellow
#property indicator_color2 Green
#property indicator_color3 Red
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2

extern int period=34;                  //   
extern int price=0;                    //     0-Close, 1-Open, 2- High, 3-Low   
extern int Shift=0;                    //    
extern int sensor=0;
extern bool bPlaySound=true;           //     
extern string SoundName="alert.wav";   //  
extern bool bAlert=true;               //  Alert
extern int CheckBar=0;                 //       

//---- buffers
double BufferGreen[];
double BufferYellow[];
double BufferRed[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   int i;
   for (i=0;i<3;i++) {
      SetIndexStyle(i,DRAW_LINE);
      SetIndexDrawBegin(i,period);
      SetIndexShift(i,Shift);
   }
   SetIndexBuffer(0,BufferYellow);
   SetIndexBuffer(1,BufferGreen);
   SetIndexBuffer(2,BufferRed);
   

   return(0); }//int init() 
//+------------------------------------------------------------------+
int start() {
   int limit;
   static int prevtime;
   double tmp1,tmp2,tmp3;
   int tmpBar, tmpTime;
   int counted_bars=IndicatorCounted();
   int i, j,k;
   limit=Bars-counted_bars;
   if(limit>2) {
      limit=Bars-period-1;
      ArrayInitialize(BufferYellow, EMPTY_VALUE);
      ArrayInitialize(BufferGreen,  EMPTY_VALUE);
      ArrayInitialize(BufferRed,    EMPTY_VALUE);
   }


   for (i = limit;i>=0;i--){
      tmp1=iMA(Symbol(),0,period,0,MODE_SMA,price,i);
      tmp2=iMA(Symbol(),0,period,0,MODE_LWMA,price,i);
      tmp3=NormalizeDouble(3.0*tmp2-2.0*tmp1,Digits);
      
      BufferYellow[i]=tmp3;
      if (MathAbs(BufferYellow[i]-BufferYellow[i+1])<sensor*Point) BufferYellow[i]=BufferYellow[i+1];
      
      BufferGreen[i] =EMPTY_VALUE;
      BufferRed[i]   =EMPTY_VALUE;

      if (BufferYellow[i]>BufferYellow[i+1]){
         BufferGreen[i]    = BufferYellow[i];
         BufferGreen[i+1]  = BufferYellow[i+1];
      } else if (BufferYellow[i]<BufferYellow[i+1]){
         BufferRed[i]      = BufferYellow[i];
         BufferRed[i+1]    = BufferYellow[i+1];
      } 
   }
   if (prevtime!=Time[0]) {
      prevtime=Time[0];
      if (BufferRed[CheckBar+1]==EMPTY_VALUE   && BufferRed[CheckBar]!=EMPTY_VALUE  ) {
         if (bPlaySound)  PlaySound(SoundName);
         if (bAlert) Alert("DN");
      }
      if (BufferGreen[CheckBar+1]==EMPTY_VALUE && BufferGreen[CheckBar]!=EMPTY_VALUE) {
         if (bPlaySound)  PlaySound(SoundName);
         if (bAlert) Alert("UP");
      }      
   }
   return(0); 
}


